# Revision in the upstream git.
%global checkout d3c5f65e

# IMPORTANT!
# Always increment firmware_release when updating this, the subprojects need
# that.
%global firmware_release 19

%global _firmwarepath /lib/firmware

Summary:	Firmware files used by the Linux kernel
Name:		linux-firmware
Version:	20170517
Release:	%{firmware_release}.git%{checkout}
License:	GPL+ and GPLv2+ and MIT and Redistributable, no modification permitted
Group:		System/Kernel and hardware
Url:		https://git.kernel.org/cgit/linux/kernel/git/firmware/linux-firmware.git/
Source0:	%{name}-%{version}.tar.xz
Provides:	kernel-firmware = %{version}
Provides:	radeon-firmware = %{version}
Provides:	ralink-firmware = %{version}
Provides:	rtlwifi-firmware = %{version}
Conflicts:	kernel-firmware-extra < 20161205
Conflicts:	microcode_ctl < 2.1-1
# The earlier builds of rtl8723bs driver included the firmware in DKMS
# package as well.
Obsoletes:	dkms-rtl8723bs < 4.4
Obsoletes:	kernel-firmware < 20161205
Obsoletes:	kernel-firmware-extra < 20161205
Obsoletes:	radeon-firmware < 20161205
Obsoletes:	ralink-firmware < 20161205
Obsoletes:	rtlwifi-firmware < 20161205
Obsoletes:	microcode < 2.1-1
Obsoletes:	ueagle-firmware < 1.1-10
BuildArch:	noarch

%description
This package includes firmware files required for some devices to
operate.

%files -f linux-firmware.files
%dir %{_firmwarepath}
%doc WHENCE LICENCE.* LICENSE.*

#----------------------------------------------------------------------------

%package -n iwlwifi-agn-ucode
Summary:	Firmware for Intel(R) Wireless WiFi 1xx/1000/.../8xxx Series Adapters
License:	Redistributable, no modification permitted
Version:	%{version}
Release:	%{firmware_release}

%description -n iwlwifi-agn-ucode
This package contains all the iwlwifi wireless firmware files supported 
by the iwlwifi kernel driver. That means all of:
iwlwifi-1xx/1000/2xxx/5xxx/6xxx/7xxx/8xxx*.ucode firmwares.

%files -n iwlwifi-agn-ucode
%doc WHENCE LICENCE.iwlwifi_firmware
%{_firmwarepath}/iwlwifi-100-5.ucode
%{_firmwarepath}/iwlwifi-105-*.ucode
%{_firmwarepath}/iwlwifi-135-*.ucode
%{_firmwarepath}/iwlwifi-1000-*.ucode
%{_firmwarepath}/iwlwifi-2000-*.ucode
%{_firmwarepath}/iwlwifi-2030-*.ucode
%{_firmwarepath}/iwlwifi-3160-*.ucode
%{_firmwarepath}/iwlwifi-3168-*.ucode
%{_firmwarepath}/iwlwifi-5000-*.ucode
%{_firmwarepath}/iwlwifi-5150-*.ucode
%{_firmwarepath}/iwlwifi-6000-*.ucode
%{_firmwarepath}/iwlwifi-6000g2a-*.ucode
%{_firmwarepath}/iwlwifi-6000g2b-*.ucode
%{_firmwarepath}/iwlwifi-6050-*.ucode
%{_firmwarepath}/iwlwifi-7260-*.ucode
%{_firmwarepath}/iwlwifi-7265*-*.ucode
%{_firmwarepath}/iwlwifi-8000*-*.ucode
%{_firmwarepath}/iwlwifi-8265*-*.ucode

#----------------------------------------------------------------------------

%package -n iwl3945-firmware
Summary:	Firmware for Intel® PRO/Wireless 3945 A/B/G network adaptors
License:	Redistributable, no modification permitted
Version:	15.32.2.9
Release:	%{firmware_release}

%description -n iwl3945-firmware
This package contains the firmware required by the iwl3945 driver
for Linux.  Usage of the firmware is subject to the terms and conditions
contained inside the provided LICENSE file. Please read it carefully.

%files -n iwl3945-firmware
%doc WHENCE LICENCE.iwlwifi_firmware
%{_firmwarepath}/iwlwifi-3945-*.ucode

#----------------------------------------------------------------------------

%package -n iwl4965-firmware
Summary:	Firmware for Intel® PRO/Wireless 4965 A/G/N network adaptors
License:	Redistributable, no modification permitted
Version:	228.61.2.24
Release:	%{firmware_release}

%description -n iwl4965-firmware
This package contains the firmware required by the iwl4965 driver
for Linux.  Usage of the firmware is subject to the terms and conditions
contained inside the provided LICENSE file. Please read it carefully.

%files -n iwl4965-firmware
%doc WHENCE LICENCE.iwlwifi_firmware
%{_firmwarepath}/iwlwifi-4965-*.ucode

#----------------------------------------------------------------------------

%package -n libertas-usb8388-firmware
Summary:	Firmware for Marvell Libertas USB 8388 Network Adapter
License:	Redistributable, no modification permitted
Epoch:		2
Obsoletes:	libertas-usb8388-firmware < 2:5.110.22.p23-8

%description -n libertas-usb8388-firmware
Firmware for Marvell Libertas USB 8388 Network Adapter.

%files -n libertas-usb8388-firmware
%doc WHENCE LICENCE.Marvell
%dir %{_firmwarepath}/libertas
%{_firmwarepath}/libertas/usb8388_v9.bin

#----------------------------------------------------------------------------

%package -n libertas-usb8388-olpc-firmware
Summary:	OLPC firmware for Marvell Libertas USB 8388 Network Adapter
License:	Redistributable, no modification permitted

%description -n libertas-usb8388-olpc-firmware
Firmware for Marvell Libertas USB 8388 Network Adapter with OLPC mesh network
support.

%files -n libertas-usb8388-olpc-firmware
%doc WHENCE LICENCE.Marvell
%dir %{_firmwarepath}/libertas
%{_firmwarepath}/libertas/usb8388_olpc.bin

#----------------------------------------------------------------------------

%package -n libertas-sd8686-firmware
Summary:	Firmware for Marvell Libertas SD 8686 Network Adapter
License:	Redistributable, no modification permitted
Obsoletes:	libertas-sd8686-firmware < 9.70.20.p0-4

%description -n libertas-sd8686-firmware
Firmware for Marvell Libertas SD 8686 Network Adapter.

%files -n libertas-sd8686-firmware
%doc WHENCE LICENCE.Marvell
%dir %{_firmwarepath}/libertas
%{_firmwarepath}/libertas/sd8686*

#----------------------------------------------------------------------------

%package -n libertas-sd8787-firmware
Summary:	Firmware for Marvell Libertas SD 8787 Network Adapter
License:	Redistributable, no modification permitted

%description -n libertas-sd8787-firmware
Firmware for Marvell Libertas SD 8787 Network Adapter.

%files -n libertas-sd8787-firmware
%doc WHENCE LICENCE.Marvell
%dir %{_firmwarepath}/mrvl
%{_firmwarepath}/mrvl/sd8787*

#----------------------------------------------------------------------------

%prep
%setup -q -n linux-firmware-%{checkout}

%build
# Remove firmware shipped in separate packages already
# Perhaps these should be built as subpackages of linux-firmware?
rm -rf ess korg sb16 yamaha
# And _some_ conexant firmware.
rm v4l-cx23418-apu.fw v4l-cx23418-cpu.fw v4l-cx23418-dig.fw v4l-cx25840.fw

# Remove source files we don't need to install
rm -f usbdux/*dux */*.asm
rm -rf carl9170fw

# No need to install old firmware versions where we also provide newer versions
# which are preferred and support the same (or more) hardware
rm -f libertas/sd8686_v8*
rm -f libertas/usb8388_v5.bin

# Remove firmware for Creative CA0132 HD as it's in alsa-firmware
rm -f ctefx.bin ctspeq.bin

%install
mkdir -p %{buildroot}/%{_firmwarepath}
mkdir -p %{buildroot}/%{_firmwarepath}/updates
cp -r * %{buildroot}/%{_firmwarepath}
rm %{buildroot}/%{_firmwarepath}/{WHENCE,LICENCE.*,LICENSE.*}

# Add the newer firmware for iwlwifi
#install -m 644 _{SOURCE1} _{SOURCE2} _{SOURCE3} _{SOURCE4} _{SOURCE5} \
#	_{buildroot}/_{_firmwarepath}

# Create file list but exclude firmwares that we place in subpackages
FILEDIR=`pwd`
pushd %{buildroot}/%{_firmwarepath}
find . \! -type d > $FILEDIR/linux-firmware.files
find . -type d | sed -e '/^.$/d' > $FILEDIR/linux-firmware.dirs
popd
sed -i -e 's:^./::' linux-firmware.{files,dirs}
sed -i -e '/^iwlwifi/d' \
	-i -e '/^libertas\/sd8686/d' \
	-i -e '/^libertas\/usb8388/d' \
	-i -e '/^mrvl\/sd8787/d' \
	linux-firmware.files
sed -i -e 's!^!/lib/firmware/!' linux-firmware.{files,dirs}
sed -e 's/^/%%dir /' linux-firmware.dirs >> linux-firmware.files


%changelog

* Wed Jun 07 2017 Evgenii Shatokhin <eugene.shatokhin@rosalab.ru> 20170517-19.gitd3c5f65e
- (14646bb) Make sure this update of linux-firmware removes the old rtl8723bs
- (14646bb) That version of the driver is likely not used anyway. Remove it
- (14646bb) automatically.


